#!/usr/bin/env python
# _*_ coding:utf-8 _*_

import oss2
import os,sys,datetime
import requests
import json
from aliyunsdkcore import client
from aliyunsdkcdn.request.v20141111 import RefreshObjectCachesRequest

Job_name = "build-android-yinli-release"
Date = datetime.datetime.today().strftime('%Y%m%d')
file_path = "/data/download_android/" + Job_name + "/apk/"

#牛耳热点接口
#OSS认证
auth = oss2.Auth('LTAIToS0DWvrGcGA', 'gG18WyJ1B5SNmPB91lSHmntCjIBGFf')
bucket_donewsdataoss = oss2.Bucket(auth, 'oss-cn-beijing.aliyuncs.com', 'donewsdataoss')
bucket_ylzx_app_upgrade = oss2.Bucket(auth, 'oss-cn-beijing.aliyuncs.com', 'ylzx-app-upgrade')
#CDN认证
clt=client.AcsClient('LTAIToS0DWvrGcGA','gG18WyJ1B5SNmPB91lSHmntCjIBGFf','cn-beijing')

def upload_duandian(file):
    """上传文件到OSS，断点续传"""
    oss2.resumable_upload(bucket, file, file,\
    store=oss2.ResumableStore(root='/tmp'),\
    multipart_threshold=100*1024,\
    part_size=100*1024,\
    num_threads=4) 

def upload_simple(file):
    """上传文件到OSS，简单上传本地文件"""
    result = bucket_donewsdataoss.put_object_from_file(file, file)
    result_2 = bucket_ylzx_app_upgrade.put_object_from_file(file, file)
    if result.status == 200 and result_2.status == 200 :
        return 200
    else:
        return 400

def FulshCDN(url):
    """刷新CDN"""
    # 设置参数
    request = RefreshObjectCachesRequest.RefreshObjectCachesRequest()
    request.set_accept_format('json')
    url = url.rstrip()
    if url[-1] is r'/':
        request.add_query_param('ObjectType', 'Directory')
    else:
        request.add_query_param('ObjectType', 'File')
    request.add_query_param('ObjectPath', url)
    # 发起请求
    response = json.loads(clt.do_action(request).decode('utf-8'))
    return response

try:
    os.chdir(file_path)
    filelist = os.listdir(file_path)
    for f in filelist:
        if "qijian" in f:
            version_v = f.split('_')[1]
    for f in filelist:
        if "tmp" not in f and "FirstHot.jks" not in f:
            print("包名：%s" % f)
            url_v = "http://donewsdata.donews.com/" + f 
            url_v_2 = "http://appupgrade.g.com.cn/" + f 
            md5_v = os.popen("md5sum " + f).read().split()[0]
            print("url:  %s ; version: %s ; md5: %s " % (url_v,version_v,md5_v))

            #上传到OSS
            upload_result = upload_simple(f)
            if upload_result is 200:
                print("%s 上传成功" % f)
            else:
                print("%s 上传失败" % f)
                sys.exit()

            #刷新CDN
            CDN_result = FulshCDN(url_v)
            print("刷新CDN：%s" % CDN_result)
            CDN_result_2 = FulshCDN(url_v_2)
            print("刷新CDN：%s" % CDN_result_2)

            #通知引力资讯CMS后台
            #r = requests.post('http://testapi.g.com.cn/v/0.1/App/upandroidsdk', data = {'url':url_v,'version':version_v,'md5':md5_v})  #测试
            r = requests.post('http://api.g.com.cn/v/0.1/App/upandroidsdk', data = {'url':url_v,'version':version_v,'md5':md5_v})       #正式
            print("通知CMS结果：%s" % r.text.encode("utf-8"))

except Exception as e:
    #logger(e)
    print(e)
